#include <stdlib.h>
#include "extstring.h"

void es_addsymbol(struct Extstring* string, char symbol) {
	if (string == NULL)
		return;
	struct Extstring* ptr = string;
	while (ptr->next != NULL) {
		ptr = ptr->next;
	};
	ptr->next = malloc(sizeof(struct Extstring));
	ptr->next->symbol = symbol;
	return;
}

int es_size(struct Extstring* string) {
	int size = 0;
	struct Extstring* ptr = string;
	for (; ptr != NULL; size++) {
		ptr = ptr->next;
	}
	return size;
}

void es_free(struct Extstring* string) {
	if (string->next == NULL) {
		free(string);
		return;
	}
	struct Extstring* ptr = string;
	struct Extstring* nextptr = ptr->next;
	while (ptr->next != NULL) {
		nextptr = ptr->next;
		free(ptr);
		ptr = nextptr;
	}
	free(ptr);
}

char* es_tostring(struct Extstring* string) {
	struct Extstring* ptr = string;
	int size = es_size(string) + 1;
	char* cstring = malloc(size);
	for (int i = 0; i != size; i++) {
		if (ptr != NULL) {
			cstring[i] = ptr->symbol;
			ptr = ptr->next;
		}
		else
			cstring[i] = 0;
	}
	return cstring;
}
